/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.237 Revision 1.374
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.237 2006/06/04 15:18:12 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.374 2011/12/17 03:57:38 reavertm Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
10inherit multilib portability 21inherit multilib portability user
11
12DEPEND="!bootstrap? ( sys-devel/patch )"
13RDEPEND=""
14# sys-apps/shadow is needed for useradd, etc, bug #94745.
15 22
16DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
17 24
18# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
19# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
20# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
21# must be an integer greater than zero. 28# @USAGE: [seconds]
22# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
23epause() { 34epause() {
24 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
25 sleep ${1:-5}
26 fi
27} 36}
28 37
29# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
30# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
31# don't beep. 40# @DESCRIPTION:
32# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
33ebeep() { 45ebeep() {
34 local n 46 local n
35 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
36 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
37 echo -ne "\a" 49 echo -ne "\a"
38 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
39 echo -ne "\a" 51 echo -ne "\a"
40 sleep 1 52 sleep 1
41 done 53 done
42 fi 54 fi
43} 55}
44 56
45# This function generate linker scripts in /usr/lib for dynamic 57else
46# libs in /lib. This is to fix linking problems when you have
47# the .so in /lib, and the .a in /usr/lib. What happens is that
48# in some cases when linking dynamic, the .a in /usr/lib is used
49# instead of the .so in /lib due to gcc/libtool tweaking ld's
50# library search path. This cause many builds to fail.
51# See bug #4411 for more info.
52#
53# To use, simply call:
54#
55# gen_usr_ldscript libfoo.so
56#
57# Note that you should in general use the unversioned name of
58# the library, as ldconfig should usually update it correctly
59# to point to the latest version of the library present.
60#
61# <azarah@gentoo.org> (26 Oct 2002)
62#
63gen_usr_ldscript() {
64 local lib libdir=$(get_libdir)
65 # Just make sure it exists
66 dodir /usr/${libdir}
67 58
68 for lib in "${@}" ; do 59ebeep() {
69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
70 /* GNU ld script 61}
71 Since Gentoo has critical dynamic libraries
72 in /lib, and the static versions in /usr/lib,
73 we need to have a "fake" dynamic lib in /usr/lib,
74 otherwise we run into linking problems.
75 62
76 See bug http://bugs.gentoo.org/4411 for more info. 63epause() {
77 */ 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
78 GROUP ( /${libdir}/${lib} ) 65}
79 END_LDSCRIPT 66
80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
81 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
82} 121}
83 122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
84 131
85# Default directory where patches are located 132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}[@]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}[${__estack_i}]}\"
147 fi
148 eval unset ${__estack_name}[${__estack_i}]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -o noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 # have to assume __ESHOPTS_SAVE__ isn't screwed with
176 # as a `declare -a` here will reset its value
177 local i=${#__ESHOPTS_SAVE__[@]}
178 if [[ $1 == -[su] ]] ; then
179 __ESHOPTS_SAVE__[$i]=$(shopt -p)
180 [[ $# -eq 0 ]] && return 0
181 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
182 else
183 __ESHOPTS_SAVE__[$i]=$-
184 [[ $# -eq 0 ]] && return 0
185 set "$@" || die "eshopts_push: bad options to set: $*"
186 fi
187}
188
189# @FUNCTION: eshopts_pop
190# @USAGE:
191# @DESCRIPTION:
192# Restore the shell options to the state saved with the corresponding
193# eshopts_push call. See that function for more details.
194eshopts_pop() {
195 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
196 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
197 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
198 local s=${__ESHOPTS_SAVE__[$i]}
199 unset __ESHOPTS_SAVE__[$i]
200 if [[ ${s} == "shopt -"* ]] ; then
201 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
202 else
203 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
204 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
205 fi
206}
207
208# @FUNCTION: eumask_push
209# @USAGE: <new umask>
210# @DESCRIPTION:
211# Set the umask to the new value specified while saving the previous
212# value onto a stack. Useful for temporarily changing the umask.
213eumask_push() {
214 estack_push eumask "$(umask)"
215 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
216}
217
218# @FUNCTION: eumask_pop
219# @USAGE:
220# @DESCRIPTION:
221# Restore the previous umask state.
222eumask_pop() {
223 local s
224 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
225 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
226}
227
228# @VARIABLE: EPATCH_SOURCE
229# @DESCRIPTION:
230# Default directory to search for patches.
86EPATCH_SOURCE="${WORKDIR}/patch" 231EPATCH_SOURCE="${WORKDIR}/patch"
87# Default extension for patches 232# @VARIABLE: EPATCH_SUFFIX
233# @DESCRIPTION:
234# Default extension for patches (do not prefix the period yourself).
88EPATCH_SUFFIX="patch.bz2" 235EPATCH_SUFFIX="patch.bz2"
236# @VARIABLE: EPATCH_OPTS
237# @DESCRIPTION:
89# Default options for patch 238# Default options for patch:
239# @CODE
90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 240# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 241# --no-backup-if-mismatch - do not leave .orig files behind
92# Set -E to automatically remove empty files. 242# -E - automatically remove empty files
243# @CODE
93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 244EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
245# @VARIABLE: EPATCH_EXCLUDE
246# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 247# List of patches not to apply. Note this is only file names,
95# and not the full path .. 248# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 249EPATCH_EXCLUDE=""
250# @VARIABLE: EPATCH_SINGLE_MSG
251# @DESCRIPTION:
97# Change the printed message for a single patch. 252# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 253EPATCH_SINGLE_MSG=""
254# @VARIABLE: EPATCH_MULTI_MSG
255# @DESCRIPTION:
99# Change the printed message for multiple patches. 256# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 257EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 258# @VARIABLE: EPATCH_FORCE
102# 259# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 260# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 261# arch naming style.
105EPATCH_FORCE="no" 262EPATCH_FORCE="no"
106 263
107# This function is for bulk patching, or in theory for just one 264# @FUNCTION: epatch
108# or two patches. 265# @USAGE: [patches] [dirs of patches]
266# @DESCRIPTION:
267# epatch is designed to greatly simplify the application of patches. It can
268# process patch files directly, or directories of patches. The patches may be
269# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
270# the -p option as epatch will automatically attempt -p0 to -p5 until things
271# apply successfully.
109# 272#
110# It should work with .bz2, .gz, .zip and plain text patches. 273# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 274# specified by EPATCH_SOURCE.
112# 275#
113# You do not have to specify '-p' option to patch, as it will 276# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 277# @CODE
115# 278# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 279# ??_${ARCH}_foo.${EPATCH_SUFFIX}
280# else
281# *.${EPATCH_SUFFIX}
282# @CODE
283# The leading ?? are typically numbers used to force consistent patch ordering.
284# The arch field is used to apply patches only for the host architecture with
285# the special value of "all" means apply for everyone. Note that using values
286# other than "all" is highly discouraged -- you should apply patches all the
287# time and let architecture details be detected at configure/compile time.
125# 288#
126# For example: 289# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
290# for patches to apply.
127# 291#
128# 01_all_misc-fix.patch.bz2 292# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 293epatch() {
141 _epatch_draw_line() { 294 _epatch_draw_line() {
295 # create a line of same length as input string
142 [[ -z $1 ]] && set "$(printf "%65s" '')" 296 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}" 297 echo "${1//?/=}"
144 } 298 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
146 local PIPE_CMD=""
147 local STDERR_TARGET="${T}/$$.out"
148 local PATCH_TARGET="${T}/$$.patch"
149 local PATCH_SUFFIX=""
150 local SINGLE_PATCH="no"
151 local x=""
152 299
153 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 300 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
154 301
155 if [ "$#" -gt 1 ] 302 # Let the rest of the code process one user arg at a time --
156 then 303 # each arg may expand into multiple patches, and each arg may
304 # need to start off with the default global EPATCH_xxx values
305 if [[ $# -gt 1 ]] ; then
157 local m="" 306 local m
158 for m in "$@" ; do 307 for m in "$@" ; do
159 epatch "${m}" 308 epatch "${m}"
160 done 309 done
161 return 0 310 return 0
162 fi 311 fi
163 312
164 if [ -n "$1" -a -f "$1" ] 313 local SINGLE_PATCH="no"
165 then 314 # no args means process ${EPATCH_SOURCE}
315 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
316
317 if [[ -f $1 ]] ; then
166 SINGLE_PATCH="yes" 318 SINGLE_PATCH="yes"
167 319 set -- "$1"
168 local EPATCH_SOURCE="$1" 320 # Use the suffix from the single patch (localize it); the code
321 # below will find the suffix for us
169 local EPATCH_SUFFIX="${1##*\.}" 322 local EPATCH_SUFFIX=$1
170 323
171 elif [ -n "$1" -a -d "$1" ] 324 elif [[ -d $1 ]] ; then
172 then 325 # Some people like to make dirs of patches w/out suffixes (vim)
173 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 326 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
174 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 327
328 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
329 # Re-use EPATCH_SOURCE as a search dir
330 epatch "${EPATCH_SOURCE}/$1"
331 return $?
332
333 else
334 # sanity check ... if it isn't a dir or file, wtf man ?
335 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
336 echo
337 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
338 eerror
339 eerror " ${EPATCH_SOURCE}"
340 eerror " ( ${EPATCH_SOURCE##*/} )"
341 echo
342 die "Cannot find \$EPATCH_SOURCE!"
343 fi
344
345 local PIPE_CMD
346 case ${EPATCH_SUFFIX##*\.} in
347 xz) PIPE_CMD="xz -dc" ;;
348 lzma) PIPE_CMD="lzma -dc" ;;
349 bz2) PIPE_CMD="bzip2 -dc" ;;
350 gz|Z|z) PIPE_CMD="gzip -dc" ;;
351 ZIP|zip) PIPE_CMD="unzip -p" ;;
352 *) ;;
353 esac
354
355 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
356
357 local x
358 for x in "$@" ; do
359 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
360 # didn't match anything, ignore continue on
361 [[ ! -f ${x} ]] && continue
362
363 local patchname=${x##*/}
364
365 # Apply single patches, or forced sets of patches, or
366 # patches with ARCH dependant names.
367 # ???_arch_foo.patch
368 # Else, skip this input altogether
369 local a=${patchname#*_} # strip the ???_
370 a=${a%%_*} # strip the _foo.patch
371 if ! [[ ${SINGLE_PATCH} == "yes" || \
372 ${EPATCH_FORCE} == "yes" || \
373 ${a} == all || \
374 ${a} == ${ARCH} ]]
175 then 375 then
176 local EPATCH_SOURCE="$1/*" 376 continue
377 fi
378
379 # Let people filter things dynamically
380 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
381 # let people use globs in the exclude
382 eshopts_push -o noglob
383
384 local ex
385 for ex in ${EPATCH_EXCLUDE} ; do
386 if [[ ${patchname} == ${ex} ]] ; then
387 eshopts_pop
388 continue 2
389 fi
390 done
391
392 eshopts_pop
393 fi
394
395 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
396 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
397 einfo "${EPATCH_SINGLE_MSG}"
398 else
399 einfo "Applying ${patchname} ..."
400 fi
177 else 401 else
178 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 402 einfo " ${patchname} ..."
179 fi 403 fi
180 else 404
181 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 405 # most of the time, there will only be one run per unique name,
182 then 406 # but if there are more, make sure we get unique log filenames
183 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 407 local STDERR_TARGET="${T}/${patchname}.out"
184 then 408 if [[ -e ${STDERR_TARGET} ]] ; then
185 EPATCH_SOURCE="$1" 409 STDERR_TARGET="${T}/${patchname}-$$.out"
410 fi
411
412 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
413
414 # Decompress the patch if need be
415 local count=0
416 local PATCH_TARGET
417 if [[ -n ${PIPE_CMD} ]] ; then
418 PATCH_TARGET="${T}/$$.patch"
419 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
420
421 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
422 echo
423 eerror "Could not extract patch!"
424 #die "Could not extract patch!"
425 count=5
426 break
186 fi 427 fi
428 else
429 PATCH_TARGET=${x}
430 fi
187 431
432 # Check for absolute paths in patches. If sandbox is disabled,
433 # people could (accidently) patch files in the root filesystem.
434 # Or trigger other unpleasantries #237667. So disallow -p0 on
435 # such patches.
436 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
437 if [[ -n ${abs_paths} ]] ; then
438 count=1
439 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
440 fi
441 # Similar reason, but with relative paths.
442 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
443 if [[ -n ${rel_paths} ]] ; then
444 eqawarn "QA Notice: Your patch uses relative paths '../'."
445 eqawarn " In the future this will cause a failure."
446 eqawarn "${rel_paths}"
447 fi
448
449 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
450 while [[ ${count} -lt 5 ]] ; do
451 # Generate some useful debug info ...
452 (
453 _epatch_draw_line "***** ${patchname} *****"
188 echo 454 echo
189 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 455 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
456 echo
457 _epatch_draw_line "***** ${patchname} *****"
458 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
459 ret=$?
460 echo
461 echo "patch program exited with status ${ret}"
462 exit ${ret}
463 ) >> "${STDERR_TARGET}"
464
465 if [ $? -eq 0 ] ; then
466 (
467 _epatch_draw_line "***** ${patchname} *****"
468 echo
469 echo "ACTUALLY APPLYING ${patchname} ..."
470 echo
471 _epatch_draw_line "***** ${patchname} *****"
472 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
473 ret=$?
474 echo
475 echo "patch program exited with status ${ret}"
476 exit ${ret}
477 ) >> "${STDERR_TARGET}"
478
479 if [ $? -ne 0 ] ; then
480 echo
481 eerror "A dry-run of patch command succeeded, but actually"
482 eerror "applying the patch failed!"
483 #die "Real world sux compared to the dreamworld!"
484 count=5
485 fi
486 break
487 fi
488
489 : $(( count++ ))
490 done
491
492 # if we had to decompress the patch, delete the temp one
493 if [[ -n ${PIPE_CMD} ]] ; then
494 rm -f "${PATCH_TARGET}"
495 fi
496
497 if [[ ${count} -ge 5 ]] ; then
498 echo
499 eerror "Failed Patch: ${patchname} !"
500 eerror " ( ${PATCH_TARGET} )"
190 eerror 501 eerror
191 eerror " ${EPATCH_SOURCE}" 502 eerror "Include in your bugreport the contents of:"
192 eerror " ( ${EPATCH_SOURCE##*/} )" 503 eerror
504 eerror " ${STDERR_TARGET}"
193 echo 505 echo
194 die "Cannot find \$EPATCH_SOURCE!"
195 fi
196
197 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
198 fi
199
200 case ${EPATCH_SUFFIX##*\.} in
201 bz2)
202 PIPE_CMD="bzip2 -dc"
203 PATCH_SUFFIX="bz2"
204 ;;
205 gz|Z|z)
206 PIPE_CMD="gzip -dc"
207 PATCH_SUFFIX="gz"
208 ;;
209 ZIP|zip)
210 PIPE_CMD="unzip -p"
211 PATCH_SUFFIX="zip"
212 ;;
213 *)
214 PIPE_CMD="cat"
215 PATCH_SUFFIX="patch"
216 ;;
217 esac
218
219 if [ "${SINGLE_PATCH}" = "no" ]
220 then
221 einfo "${EPATCH_MULTI_MSG}"
222 fi
223 for x in ${EPATCH_SOURCE}
224 do
225 # New ARCH dependant patch naming scheme ...
226 #
227 # ???_arch_foo.patch
228 #
229 if [ -f ${x} ] && \
230 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
231 [ "${EPATCH_FORCE}" = "yes" ])
232 then
233 local count=0
234 local popts="${EPATCH_OPTS}"
235 local patchname=${x##*/}
236
237 if [ -n "${EPATCH_EXCLUDE}" ]
238 then
239 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
240 then
241 continue
242 fi
243 fi
244
245 if [ "${SINGLE_PATCH}" = "yes" ]
246 then
247 if [ -n "${EPATCH_SINGLE_MSG}" ]
248 then
249 einfo "${EPATCH_SINGLE_MSG}"
250 else
251 einfo "Applying ${patchname} ..."
252 fi
253 else
254 einfo " ${patchname} ..."
255 fi
256
257 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
259
260 # Allow for prefix to differ ... im lazy, so shoot me :/
261 while [ "${count}" -lt 5 ]
262 do
263 # Generate some useful debug info ...
264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 else
272 PATCH_TARGET="${x}"
273 fi
274
275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280
281 if [ "${PATCH_SUFFIX}" != "patch" ]
282 then
283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
284 then
285 echo
286 eerror "Could not extract patch!"
287 #die "Could not extract patch!"
288 count=5
289 break
290 fi
291 fi
292
293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
294 then
295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300
301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
303
304 if [ "$?" -ne 0 ]
305 then
306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
307 echo
308 eerror "A dry-run of patch command succeeded, but actually"
309 eerror "applying the patch failed!"
310 #die "Real world sux compared to the dreamworld!"
311 count=5
312 fi
313
314 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
315
316 break
317 fi
318
319 count=$((count + 1))
320 done
321
322 if [ "${PATCH_SUFFIX}" != "patch" ]
323 then
324 rm -f ${PATCH_TARGET}
325 fi
326
327 if [ "${count}" -eq 5 ]
328 then
329 echo
330 eerror "Failed Patch: ${patchname} !"
331 eerror " ( ${PATCH_TARGET} )"
332 eerror
333 eerror "Include in your bugreport the contents of:"
334 eerror
335 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
336 echo
337 die "Failed Patch: ${patchname}!" 506 die "Failed Patch: ${patchname}!"
338 fi 507 fi
339 508
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 509 # if everything worked, delete the patch log
341 510 rm -f "${STDERR_TARGET}"
342 eend 0 511 eend 0
343 fi
344 done 512 done
345 if [ "${SINGLE_PATCH}" = "no" ] 513
346 then 514 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
347 einfo "Done with patching" 515 : # everything worked
516}
517
518# @FUNCTION: epatch_user
519# @USAGE:
520# @DESCRIPTION:
521# Applies user-provided patches to the source tree. The patches are
522# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
523# of these three directories to exist will be the one to use, ignoring
524# any more general directories which might exist as well.
525#
526# User patches are intended for quick testing of patches without ebuild
527# modifications, as well as for permanent customizations a user might
528# desire. Obviously, there can be no official support for arbitrarily
529# patched ebuilds. So whenever a build log in a bug report mentions that
530# user patches were applied, the user should be asked to reproduce the
531# problem without these.
532#
533# Not all ebuilds do call this function, so placing patches in the
534# stated directory might or might not work, depending on the package and
535# the eclasses it inherits and uses. It is safe to call the function
536# repeatedly, so it is always possible to add a call at the ebuild
537# level. The first call is the time when the patches will be
538# applied.
539#
540# Ideally, this function should be called after gentoo-specific patches
541# have been applied, so that their code can be modified as well, but
542# before calls to e.g. eautoreconf, as the user patches might affect
543# autotool input files as well.
544epatch_user() {
545 [[ $# -ne 0 ]] && die "epatch_user takes no options"
546
547 # Allow multiple calls to this function; ignore all but the first
548 local applied="${T}/epatch_user.applied"
549 [[ -e ${applied} ]] && return 2
550
551 # don't clobber any EPATCH vars that the parent might want
552 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
553 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
554 EPATCH_SOURCE=${base}/${CTARGET}/${check}
555 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
556 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
557 if [[ -d ${EPATCH_SOURCE} ]] ; then
558 EPATCH_SOURCE=${EPATCH_SOURCE} \
559 EPATCH_SUFFIX="patch" \
560 EPATCH_FORCE="yes" \
561 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
562 epatch
563 echo "${EPATCH_SOURCE}" > "${applied}"
564 return 0
348 fi 565 fi
566 done
567 echo "none" > "${applied}"
568 return 1
349} 569}
350 570
571# @FUNCTION: emktemp
572# @USAGE: [temp dir]
573# @DESCRIPTION:
351# Cheap replacement for when debianutils (and thus mktemp) 574# Cheap replacement for when debianutils (and thus mktemp)
352# does not exist on the users system 575# does not exist on the users system.
353# vapier@gentoo.org
354#
355# Takes just 1 optional parameter (the directory to create tmpfile in)
356emktemp() { 576emktemp() {
357 local exe="touch" 577 local exe="touch"
358 [[ $1 == -d ]] && exe="mkdir" && shift 578 [[ $1 == -d ]] && exe="mkdir" && shift
359 local topdir=$1 579 local topdir=$1
360 580
362 [[ -z ${T} ]] \ 582 [[ -z ${T} ]] \
363 && topdir="/tmp" \ 583 && topdir="/tmp" \
364 || topdir=${T} 584 || topdir=${T}
365 fi 585 fi
366 586
367 if [[ -z $(type -p mktemp) ]] ; then 587 if ! type -P mktemp > /dev/null ; then
588 # system lacks `mktemp` so we have to fake it
368 local tmp=/ 589 local tmp=/
369 while [[ -e ${tmp} ]] ; do 590 while [[ -e ${tmp} ]] ; do
370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 591 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
371 done 592 done
372 ${exe} "${tmp}" || ${exe} -p "${tmp}" 593 ${exe} "${tmp}" || ${exe} -p "${tmp}"
373 echo "${tmp}" 594 echo "${tmp}"
374 else 595 else
596 # the args here will give slightly wierd names on BSD,
597 # but should produce a usable file on all userlands
375 if [[ ${exe} == "touch" ]] ; then 598 if [[ ${exe} == "touch" ]] ; then
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -p "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -t tmp 599 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
379 else 600 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp 601 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
383 fi
384 fi
385}
386
387# Small wrapper for getent (Linux), nidump (Mac OS X),
388# and pw (FreeBSD) used in enewuser()/enewgroup()
389# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
390# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
391#
392# egetent(database, key)
393egetent() {
394 case ${CHOST} in
395 *-darwin*)
396 case "$2" in
397 *[!0-9]*) # Non numeric
398 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
399 ;;
400 *) # Numeric
401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
402 ;;
403 esac
404 ;;
405 *-freebsd*|*-dragonfly*)
406 local opts action="user"
407 [[ $1 == "passwd" ]] || action="group"
408
409 # lookup by uid/gid
410 if [[ $2 == [[:digit:]]* ]] ; then
411 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
412 fi
413
414 pw show ${action} ${opts} "$2" -q
415 ;;
416 *-netbsd*|*-openbsd*)
417 grep "$2:\*:" /etc/$1
418 ;;
419 *)
420 type -p nscd >& /dev/null && nscd -i "$1"
421 getent "$1" "$2"
422 ;;
423 esac
424}
425
426# Simplify/standardize adding users to the system
427# vapier@gentoo.org
428#
429# enewuser(username, uid, shell, homedir, groups, extra options)
430#
431# Default values if you do not specify any:
432# username: REQUIRED !
433# uid: next available (see useradd(8))
434# note: pass -1 to get default behavior
435# shell: /bin/false
436# homedir: /dev/null
437# groups: none
438# extra: comment of 'added by portage for ${PN}'
439enewuser() {
440 case ${EBUILD_PHASE} in
441 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug."
444 die "Bad package! enewuser is only for use in pkg_* functions!"
445 esac
446
447 # get the username
448 local euser=$1; shift
449 if [[ -z ${euser} ]] ; then
450 eerror "No username specified !"
451 die "Cannot call enewuser without a username"
452 fi
453
454 # lets see if the username already exists
455 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
456 return 0
457 fi
458 einfo "Adding user '${euser}' to your system ..."
459
460 # options to pass to useradd
461 local opts=
462
463 # handle uid
464 local euid=$1; shift
465 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
466 if [[ ${euid} -gt 0 ]] ; then
467 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
468 euid="next"
469 fi 602 fi
470 else
471 eerror "Userid given but is not greater than 0 !"
472 die "${euid} is not a valid UID"
473 fi 603 fi
474 else
475 euid="next"
476 fi
477 if [[ ${euid} == "next" ]] ; then
478 for euid in $(seq 101 999) ; do
479 [[ -z $(egetent passwd ${euid}) ]] && break
480 done
481 fi
482 opts="${opts} -u ${euid}"
483 einfo " - Userid: ${euid}"
484
485 # handle shell
486 local eshell=$1; shift
487 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
488 if [[ ! -e ${ROOT}${eshell} ]] ; then
489 eerror "A shell was specified but it does not exist !"
490 die "${eshell} does not exist in ${ROOT}"
491 fi
492 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
493 eerror "Do not specify ${eshell} yourself, use -1"
494 die "Pass '-1' as the shell parameter"
495 fi
496 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break
499 done
500
501 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use"
504 fi
505
506 eshell=${shell}
507 fi
508 einfo " - Shell: ${eshell}"
509 opts="${opts} -s ${eshell}"
510
511 # handle homedir
512 local ehome=$1; shift
513 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
514 ehome="/dev/null"
515 fi
516 einfo " - Home: ${ehome}"
517 opts="${opts} -d ${ehome}"
518
519 # handle groups
520 local egroups=$1; shift
521 if [[ ! -z ${egroups} ]] ; then
522 local oldifs=${IFS}
523 local defgroup="" exgroups=""
524
525 export IFS=","
526 for g in ${egroups} ; do
527 export IFS=${oldifs}
528 if [[ -z $(egetent group "${g}") ]] ; then
529 eerror "You must add group ${g} to the system first"
530 die "${g} is not a valid GID"
531 fi
532 if [[ -z ${defgroup} ]] ; then
533 defgroup=${g}
534 else
535 exgroups="${exgroups},${g}"
536 fi
537 export IFS=","
538 done
539 export IFS=${oldifs}
540
541 opts="${opts} -g ${defgroup}"
542 if [[ ! -z ${exgroups} ]] ; then
543 opts="${opts} -G ${exgroups:1}"
544 fi
545 else
546 egroups="(none)"
547 fi
548 einfo " - Groups: ${egroups}"
549
550 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0"
553 case ${CHOST} in
554 *-darwin*)
555 ### Make the user
556 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome}
560 dscl . create /users/${euser} realname "added by portage for ${PN}"
561 ### Add the user to the groups specified
562 local oldifs=${IFS}
563 export IFS=","
564 for g in ${egroups} ; do
565 dscl . merge /groups/${g} users ${euser}
566 done
567 export IFS=${oldifs}
568 else
569 einfo "Extra options are not supported on Darwin yet"
570 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@"
572 die "Required function missing"
573 fi
574 ;;
575 *-freebsd*|*-dragonfly*)
576 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \
579 die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed"
584 fi
585 ;;
586
587 *-netbsd*)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} || die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 useradd ${opts} ${euser} "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-openbsd*)
597 if [[ -z $@ ]] ; then
598 useradd -u ${euid} -s ${eshell} \
599 -d ${ehome} -c "Added by portage for ${PN}" \
600 -g ${egroups} ${euser} || die "enewuser failed"
601 else
602 einfo " - Extra: $@"
603 useradd -u ${euid} -s ${eshell} \
604 -d ${ehome} -c "Added by portage for ${PN}" \
605 -g ${egroups} ${euser} "$@" || die "enewuser failed"
606 fi
607 ;;
608
609 *)
610 if [[ -z $@ ]] ; then
611 useradd ${opts} ${euser} \
612 -c "added by portage for ${PN}" \
613 || die "enewuser failed"
614 else
615 einfo " - Extra: $@"
616 useradd ${opts} ${euser} "$@" \
617 || die "enewuser failed"
618 fi
619 ;;
620 esac
621
622 if [[ ! -e ${ROOT}/${ehome} ]] ; then
623 einfo " - Creating ${ehome} in ${ROOT}"
624 mkdir -p "${ROOT}/${ehome}"
625 chown ${euser} "${ROOT}/${ehome}"
626 chmod 755 "${ROOT}/${ehome}"
627 fi
628
629 export SANDBOX_ON=${oldsandbox}
630} 604}
631 605
632# Simplify/standardize adding groups to the system 606# @FUNCTION: edos2unix
633# vapier@gentoo.org 607# @USAGE: <file> [more files ...]
634# 608# @DESCRIPTION:
635# enewgroup(group, gid) 609# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
636# 610# to remove all of these text utilities from DEPEND variables because this
637# Default values if you do not specify any: 611# is a script based solution. Just give it a list of files to convert and
638# groupname: REQUIRED ! 612# they will all be changed from the DOS CRLF format to the UNIX LF format.
639# gid: next available (see groupadd(8))
640# extra: none
641enewgroup() {
642 case ${EBUILD_PHASE} in
643 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug."
646 die "Bad package! enewgroup is only for use in pkg_* functions!"
647 esac
648
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 613edos2unix() {
752 for f in "$@" 614 [[ $# -eq 0 ]] && return 0
753 do 615 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 616}
758
759
760##############################################################
761# START: Handle .desktop files and menu entries #
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765 617
766# Make a desktop file ! 618# Make a desktop file !
767# Great for making those icons in kde/gnome startmenu ! 619# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today ! 620# Amaze your friends ! Get the women ! Join today !
769# 621#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 622# make_desktop_entry(<command>, [name], [icon], [type], [fields])
771# 623#
772# binary: what binary does the app run with ? 624# binary: what command does the app run with ?
773# name: the name that will show up in the menu 625# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 626# icon: give your little like a pretty little icon ...
775# this can be relative (to /usr/share/pixmaps) or 627# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 628# a full path to an icon
777# type: what kind of application is this ? for categories: 629# type: what kind of application is this ? for categories:
778# http://www.freedesktop.org/Standards/desktop-entry-spec 630# http://standards.freedesktop.org/menu-spec/latest/apa.html
779# path: if your app needs to startup in a specific dir 631# fields: extra fields to append to the desktop file; a printf string
780make_desktop_entry() { 632make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 633 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 634
783 local exec=${1} 635 local exec=${1}
784 local name=${2:-${PN}} 636 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 637 local icon=${3:-${PN}}
786 local type=${4} 638 local type=${4}
787 local path=${5} 639 local fields=${5}
788 640
789 if [[ -z ${type} ]] ; then 641 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 642 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 643 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 644 case ${catmaj} in
793 app) 645 app)
794 case ${catmin} in 646 case ${catmin} in
647 accessibility) type=Accessibility;;
795 admin) type=System;; 648 admin) type=System;;
649 antivirus) type=System;;
650 arch) type=Archiving;;
651 backup) type=Archiving;;
796 cdr) type=DiscBurning;; 652 cdr) type=DiscBurning;;
797 dicts) type=Dictionary;; 653 dicts) type=Dictionary;;
654 doc) type=Documentation;;
798 editors) type=TextEditor;; 655 editors) type=TextEditor;;
799 emacs) type=TextEditor;; 656 emacs) type=TextEditor;;
800 emulation) type=Emulator;; 657 emulation) type=Emulator;;
801 laptop) type=HardwareSettings;; 658 laptop) type=HardwareSettings;;
802 office) type=Office;; 659 office) type=Office;;
660 pda) type=PDA;;
803 vim) type=TextEditor;; 661 vim) type=TextEditor;;
804 xemacs) type=TextEditor;; 662 xemacs) type=TextEditor;;
805 *) type=;;
806 esac 663 esac
807 ;; 664 ;;
808 665
809 dev) 666 dev)
810 type="Development" 667 type="Development"
811 ;; 668 ;;
812 669
813 games) 670 games)
814 case ${catmin} in 671 case ${catmin} in
815 action) type=ActionGame;; 672 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 673 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 674 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 675 emulation) type=Emulator;;
676 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 677 puzzle) type=LogicGame;;
678 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 679 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 680 simulation) type=Simulation;;
824 sports) type=SportsGame;; 681 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 682 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 683 esac
828 type="Game;${type}" 684 type="Game;${type}"
829 ;; 685 ;;
830 686
687 gnome)
688 type="Gnome;GTK"
689 ;;
690
691 kde)
692 type="KDE;Qt"
693 ;;
694
831 mail) 695 mail)
832 type="Network;Email" 696 type="Network;Email"
833 ;; 697 ;;
834 698
835 media) 699 media)
836 case ${catmin} in 700 case ${catmin} in
701 gfx)
837 gfx) type=Graphics;; 702 type=Graphics
703 ;;
704 *)
705 case ${catmin} in
838 radio) type=Tuner;; 706 radio) type=Tuner;;
839 sound) type=Audio;; 707 sound) type=Audio;;
840 tv) type=TV;; 708 tv) type=TV;;
841 video) type=Video;; 709 video) type=Video;;
842 *) type=;; 710 esac
711 type="AudioVideo;${type}"
712 ;;
843 esac 713 esac
844 type="AudioVideo;${type}"
845 ;; 714 ;;
846 715
847 net) 716 net)
848 case ${catmin} in 717 case ${catmin} in
849 dialup) type=Dialup;; 718 dialup) type=Dialup;;
852 irc) type=IRCClient;; 721 irc) type=IRCClient;;
853 mail) type=Email;; 722 mail) type=Email;;
854 news) type=News;; 723 news) type=News;;
855 nntp) type=News;; 724 nntp) type=News;;
856 p2p) type=FileTransfer;; 725 p2p) type=FileTransfer;;
857 *) type=;; 726 voip) type=Telephony;;
858 esac 727 esac
859 type="Network;${type}" 728 type="Network;${type}"
860 ;; 729 ;;
861 730
862 sci) 731 sci)
863 case ${catmin} in 732 case ${catmin} in
864 astro*) type=Astronomy;; 733 astro*) type=Astronomy;;
865 bio*) type=Biology;; 734 bio*) type=Biology;;
866 calc*) type=Calculator;; 735 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 736 chem*) type=Chemistry;;
737 elec*) type=Electronics;;
868 geo*) type=Geology;; 738 geo*) type=Geology;;
869 math*) type=Math;; 739 math*) type=Math;;
870 *) type=;; 740 physics) type=Physics;;
741 visual*) type=DataVisualization;;
871 esac 742 esac
872 type="Science;${type}" 743 type="Education;Science;${type}"
744 ;;
745
746 sys)
747 type="System"
873 ;; 748 ;;
874 749
875 www) 750 www)
876 case ${catmin} in 751 case ${catmin} in
877 client) type=WebBrowser;; 752 client) type=WebBrowser;;
878 *) type=;;
879 esac 753 esac
880 type="Network" 754 type="Network;${type}"
881 ;; 755 ;;
882 756
883 *) 757 *)
884 type= 758 type=
885 ;; 759 ;;
888 if [ "${SLOT}" == "0" ] ; then 762 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 763 local desktop_name="${PN}"
890 else 764 else
891 local desktop_name="${PN}-${SLOT}" 765 local desktop_name="${PN}-${SLOT}"
892 fi 766 fi
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 767 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 768 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 769
770 # Don't append another ";" when a valid category value is provided.
771 type=${type%;}${type:+;}
772
773 eshopts_push -s extglob
774 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
775 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
776 ewarn "allowed in .desktop files if the value is not an absolute path."
777 icon=${icon%.@(xpm|png|svg)}
778 fi
779 eshopts_pop
780
781 cat <<-EOF > "${desktop}"
896echo "[Desktop Entry] 782 [Desktop Entry]
897Encoding=UTF-8
898Version=0.9.2
899Name=${name} 783 Name=${name}
900Type=Application 784 Type=Application
901Comment=${DESCRIPTION} 785 Comment=${DESCRIPTION}
902Exec=${exec} 786 Exec=${exec}
903TryExec=${exec} 787 TryExec=${exec%% *}
904Path=${path}
905Icon=${icon} 788 Icon=${icon}
906Categories=Application;${type};" > "${desktop}" 789 Categories=${type}
790 EOF
791
792 if [[ ${fields:-=} != *=* ]] ; then
793 # 5th arg used to be value to Path=
794 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
795 fields="Path=${fields}"
796 fi
797 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
907 798
908 ( 799 (
909 # wrap the env here so that the 'insinto' call 800 # wrap the env here so that the 'insinto' call
910 # doesn't corrupt the env of the caller 801 # doesn't corrupt the env of the caller
911 insinto /usr/share/applications 802 insinto /usr/share/applications
912 doins "${desktop}" 803 doins "${desktop}"
913 ) 804 ) || die "installing desktop file failed"
914} 805}
915 806
916# Make a GDM/KDM Session file 807# @FUNCTION: validate_desktop_entries
917# 808# @USAGE: [directories]
918# make_desktop_entry(<title>, <command>) 809# @MAINTAINER:
919# title: File to execute to start the Window Manager 810# Carsten Lohrke <carlo@gentoo.org>
920# command: Name of the Window Manager 811# @DESCRIPTION:
812# Validate desktop entries using desktop-file-utils
813validate_desktop_entries() {
814 if [[ -x /usr/bin/desktop-file-validate ]] ; then
815 einfo "Checking desktop entry validity"
816 local directories=""
817 for d in /usr/share/applications $@ ; do
818 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
819 done
820 if [[ -n ${directories} ]] ; then
821 for FILE in $(find ${directories} -name "*\.desktop" \
822 -not -path '*.hidden*' | sort -u 2>/dev/null)
823 do
824 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
825 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
826 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
827 done
828 fi
829 echo ""
830 else
831 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
832 fi
833}
921 834
835# @FUNCTION: make_session_desktop
836# @USAGE: <title> <command> [command args...]
837# @DESCRIPTION:
838# Make a GDM/KDM Session file. The title is the file to execute to start the
839# Window Manager. The command is the name of the Window Manager.
840#
841# You can set the name of the file via the ${wm} variable.
922make_session_desktop() { 842make_session_desktop() {
923 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 843 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
924 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 844 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
925 845
926 local title=$1 846 local title=$1
927 local command=$2 847 local command=$2
928 local desktop=${T}/${wm}.desktop 848 local desktop=${T}/${wm:-${PN}}.desktop
849 shift 2
929 850
851 cat <<-EOF > "${desktop}"
930echo "[Desktop Entry] 852 [Desktop Entry]
931Encoding=UTF-8
932Name=${title} 853 Name=${title}
933Comment=This session logs you into ${title} 854 Comment=This session logs you into ${title}
934Exec=${command} 855 Exec=${command} $*
935TryExec=${command} 856 TryExec=${command}
936Type=Application" > "${desktop}" 857 Type=XSession
858 EOF
937 859
860 (
861 # wrap the env here so that the 'insinto' call
862 # doesn't corrupt the env of the caller
938 insinto /usr/share/xsessions 863 insinto /usr/share/xsessions
939 doins "${desktop}" 864 doins "${desktop}"
865 )
940} 866}
941 867
868# @FUNCTION: domenu
869# @USAGE: <menus>
870# @DESCRIPTION:
871# Install the list of .desktop menu files into the appropriate directory
872# (/usr/share/applications).
942domenu() { 873domenu() {
874 (
875 # wrap the env here so that the 'insinto' call
876 # doesn't corrupt the env of the caller
943 local i j 877 local i j ret=0
944 insinto /usr/share/applications 878 insinto /usr/share/applications
945 for i in "$@" ; do 879 for i in "$@" ; do
946 if [[ -f ${i} ]] ; then 880 if [[ -f ${i} ]] ; then
947 doins "${i}" 881 doins "${i}"
882 ((ret+=$?))
948 elif [[ -d ${i} ]] ; then 883 elif [[ -d ${i} ]] ; then
949 for j in "${i}"/*.desktop ; do 884 for j in "${i}"/*.desktop ; do
950 doins "${j}" 885 doins "${j}"
886 ((ret+=$?))
951 done 887 done
888 else
889 ((++ret))
952 fi 890 fi
953 done 891 done
892 exit ${ret}
893 )
954} 894}
895
896# @FUNCTION: newmenu
897# @USAGE: <menu> <newname>
898# @DESCRIPTION:
899# Like all other new* functions, install the specified menu as newname.
955newmenu() { 900newmenu() {
901 (
902 # wrap the env here so that the 'insinto' call
903 # doesn't corrupt the env of the caller
956 insinto /usr/share/applications 904 insinto /usr/share/applications
957 newins "$1" "$2" 905 newins "$@"
906 )
958} 907}
959 908
909# @FUNCTION: doicon
910# @USAGE: <list of icons>
911# @DESCRIPTION:
912# Install the list of icons into the icon directory (/usr/share/pixmaps).
913# This is useful in conjunction with creating desktop/menu files.
960doicon() { 914doicon() {
915 (
916 # wrap the env here so that the 'insinto' call
917 # doesn't corrupt the env of the caller
961 local i j 918 local i j ret
962 insinto /usr/share/pixmaps 919 insinto /usr/share/pixmaps
963 for i in "$@" ; do 920 for i in "$@" ; do
964 if [[ -f ${i} ]] ; then 921 if [[ -f ${i} ]] ; then
965 doins "${i}" 922 doins "${i}"
923 ((ret+=$?))
966 elif [[ -d ${i} ]] ; then 924 elif [[ -d ${i} ]] ; then
967 for j in "${i}"/*.png ; do 925 for j in "${i}"/*.png ; do
968 doins "${j}" 926 doins "${j}"
927 ((ret+=$?))
969 done 928 done
929 else
930 ((++ret))
970 fi 931 fi
971 done 932 done
933 exit ${ret}
934 )
972} 935}
936
937# @FUNCTION: newicon
938# @USAGE: <icon> <newname>
939# @DESCRIPTION:
940# Like all other new* functions, install the specified icon as newname.
973newicon() { 941newicon() {
942 (
943 # wrap the env here so that the 'insinto' call
944 # doesn't corrupt the env of the caller
974 insinto /usr/share/pixmaps 945 insinto /usr/share/pixmaps
975 newins "$1" "$2" 946 newins "$@"
947 )
976} 948}
977
978##############################################################
979# END: Handle .desktop files and menu entries #
980##############################################################
981
982 949
983# for internal use only (unpack_pdv and unpack_makeself) 950# for internal use only (unpack_pdv and unpack_makeself)
984find_unpackable_file() { 951find_unpackable_file() {
985 local src=$1 952 local src=$1
986 if [[ -z ${src} ]] ; then 953 if [[ -z ${src} ]] ; then
996 fi 963 fi
997 [[ ! -e ${src} ]] && return 1 964 [[ ! -e ${src} ]] && return 1
998 echo "${src}" 965 echo "${src}"
999} 966}
1000 967
968# @FUNCTION: unpack_pdv
969# @USAGE: <file to unpack> <size of off_t>
970# @DESCRIPTION:
1001# Unpack those pesky pdv generated files ... 971# Unpack those pesky pdv generated files ...
1002# They're self-unpacking programs with the binary package stuffed in 972# They're self-unpacking programs with the binary package stuffed in
1003# the middle of the archive. Valve seems to use it a lot ... too bad 973# the middle of the archive. Valve seems to use it a lot ... too bad
1004# it seems to like to segfault a lot :(. So lets take it apart ourselves. 974# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1005# 975#
1006# Usage: unpack_pdv [file to unpack] [size of off_t]
1007# - you have to specify the off_t size ... i have no idea how to extract that 976# You have to specify the off_t size ... I have no idea how to extract that
1008# information out of the binary executable myself. basically you pass in 977# information out of the binary executable myself. Basically you pass in
1009# the size of the off_t type (in bytes) on the machine that built the pdv 978# the size of the off_t type (in bytes) on the machine that built the pdv
979# archive.
980#
1010# archive. one way to determine this is by running the following commands: 981# One way to determine this is by running the following commands:
982#
983# @CODE
1011# strings <pdv archive> | grep lseek 984# strings <pdv archive> | grep lseek
1012# strace -elseek <pdv archive> 985# strace -elseek <pdv archive>
986# @CODE
987#
1013# basically look for the first lseek command (we do the strings/grep because 988# Basically look for the first lseek command (we do the strings/grep because
1014# sometimes the function call is _llseek or something) and steal the 2nd 989# sometimes the function call is _llseek or something) and steal the 2nd
1015# parameter. here is an example: 990# parameter. Here is an example:
991#
992# @CODE
1016# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 993# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1017# lseek 994# lseek
1018# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 995# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1019# lseek(3, -4, SEEK_END) = 2981250 996# lseek(3, -4, SEEK_END) = 2981250
997# @CODE
998#
1020# thus we would pass in the value of '4' as the second parameter. 999# Thus we would pass in the value of '4' as the second parameter.
1021unpack_pdv() { 1000unpack_pdv() {
1022 local src=$(find_unpackable_file $1) 1001 local src=$(find_unpackable_file "$1")
1023 local sizeoff_t=$2 1002 local sizeoff_t=$2
1024 1003
1025 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1004 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1005 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1027 1006
1028 local shrtsrc=$(basename "${src}") 1007 local shrtsrc=$(basename "${src}")
1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1008 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1009 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1010 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1032 1011
1033 # grab metadata for debug reasons 1012 # grab metadata for debug reasons
1034 local metafile="$(emktemp)" 1013 local metafile=$(emktemp)
1035 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1014 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1036 1015
1037 # rip out the final file name from the metadata 1016 # rip out the final file name from the metadata
1038 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1017 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1039 datafile="`basename ${datafile}`" 1018 datafile=$(basename "${datafile}")
1040 1019
1041 # now lets uncompress/untar the file if need be 1020 # now lets uncompress/untar the file if need be
1042 local tmpfile="$(emktemp)" 1021 local tmpfile=$(emktemp)
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1022 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1044 1023
1045 local iscompressed="`file -b ${tmpfile}`" 1024 local iscompressed=$(file -b "${tmpfile}")
1046 if [ "${iscompressed:0:8}" == "compress" ] ; then 1025 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1047 iscompressed=1 1026 iscompressed=1
1048 mv ${tmpfile}{,.Z} 1027 mv ${tmpfile}{,.Z}
1049 gunzip ${tmpfile} 1028 gunzip ${tmpfile}
1050 else 1029 else
1051 iscompressed=0 1030 iscompressed=0
1052 fi 1031 fi
1053 local istar="`file -b ${tmpfile}`" 1032 local istar=$(file -b "${tmpfile}")
1054 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1033 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1055 istar=1 1034 istar=1
1056 else 1035 else
1057 istar=0 1036 istar=0
1058 fi 1037 fi
1059 1038
1087 true 1066 true
1088 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1067 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1089 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1068 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090} 1069}
1091 1070
1071# @FUNCTION: unpack_makeself
1072# @USAGE: [file to unpack] [offset] [tail|dd]
1073# @DESCRIPTION:
1092# Unpack those pesky makeself generated files ... 1074# Unpack those pesky makeself generated files ...
1093# They're shell scripts with the binary package tagged onto 1075# They're shell scripts with the binary package tagged onto
1094# the end of the archive. Loki utilized the format as does 1076# the end of the archive. Loki utilized the format as does
1095# many other game companies. 1077# many other game companies.
1096# 1078#
1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1079# If the file is not specified, then ${A} is used. If the
1098# - If the file is not specified then unpack will utilize ${A}.
1099# - If the offset is not specified then we will attempt to extract 1080# offset is not specified then we will attempt to extract
1100# the proper offset from the script itself. 1081# the proper offset from the script itself.
1101unpack_makeself() { 1082unpack_makeself() {
1102 local src_input=${1:-${A}} 1083 local src_input=${1:-${A}}
1103 local src=$(find_unpackable_file "${src_input}") 1084 local src=$(find_unpackable_file "${src_input}")
1104 local skip=$2 1085 local skip=$2
1105 local exe=$3 1086 local exe=$3
1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1088 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1108 1089
1109 local shrtsrc=$(basename "${src}") 1090 local shrtsrc=$(basename "${src}")
1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1091 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1111 if [[ -z ${skip} ]] ; then 1092 if [[ -z ${skip} ]] ; then
1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1093 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1113 local skip=0 1094 local skip=0
1114 exe=tail 1095 exe=tail
1115 case ${ver} in 1096 case ${ver} in
1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1097 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1098 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1118 ;; 1099 ;;
1119 2.0|2.0.1) 1100 2.0|2.0.1)
1120 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1101 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1121 ;; 1102 ;;
1122 2.1.1) 1103 2.1.1)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1104 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1124 let skip="skip + 1" 1105 (( skip++ ))
1125 ;; 1106 ;;
1126 2.1.2) 1107 2.1.2)
1127 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1108 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1128 let skip="skip + 1" 1109 (( skip++ ))
1129 ;; 1110 ;;
1130 2.1.3) 1111 2.1.3)
1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1112 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1132 let skip="skip + 1" 1113 (( skip++ ))
1133 ;; 1114 ;;
1134 2.1.4|2.1.5) 1115 2.1.4|2.1.5)
1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1116 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1136 skip=$(head -n ${skip} "${src}" | wc -c) 1117 skip=$(head -n ${skip} "${src}" | wc -c)
1137 exe="dd" 1118 exe="dd"
1146 esac 1127 esac
1147 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1128 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1148 fi 1129 fi
1149 case ${exe} in 1130 case ${exe} in
1150 tail) exe="tail -n +${skip} '${src}'";; 1131 tail) exe="tail -n +${skip} '${src}'";;
1151 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1132 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1152 *) die "makeself cant handle exe '${exe}'" 1133 *) die "makeself cant handle exe '${exe}'"
1153 esac 1134 esac
1154 1135
1155 # lets grab the first few bytes of the file to figure out what kind of archive it is 1136 # lets grab the first few bytes of the file to figure out what kind of archive it is
1156 local tmpfile="$(emktemp)" 1137 local filetype tmpfile=$(emktemp)
1157 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1138 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1158 local filetype="$(file -b "${tmpfile}")" 1139 filetype=$(file -b "${tmpfile}") || die
1159 case ${filetype} in 1140 case ${filetype} in
1160 *tar\ archive) 1141 *tar\ archive*)
1161 eval ${exe} | tar --no-same-owner -xf - 1142 eval ${exe} | tar --no-same-owner -xf -
1162 ;; 1143 ;;
1163 bzip2*) 1144 bzip2*)
1164 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1145 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1165 ;; 1146 ;;
1175 ;; 1156 ;;
1176 esac 1157 esac
1177 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1158 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1178} 1159}
1179 1160
1180# Display a license for user to accept. 1161# @FUNCTION: cdrom_get_cds
1181# 1162# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1182# Usage: check_license [license] 1163# @DESCRIPTION:
1183# - If the file is not specified then ${LICENSE} is used.
1184check_license() {
1185 local lic=$1
1186 if [ -z "${lic}" ] ; then
1187 lic="${PORTDIR}/licenses/${LICENSE}"
1188 else
1189 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1190 lic="${PORTDIR}/licenses/${lic}"
1191 elif [ -e "${PWD}/${lic}" ] ; then
1192 lic="${PWD}/${lic}"
1193 elif [ -e "${lic}" ] ; then
1194 lic="${lic}"
1195 fi
1196 fi
1197 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1198 local l="`basename ${lic}`"
1199
1200 # here is where we check for the licenses the user already
1201 # accepted ... if we don't find a match, we make the user accept
1202 local shopts=$-
1203 local alic
1204 set -o noglob #so that bash doesn't expand "*"
1205 for alic in ${ACCEPT_LICENSE} ; do
1206 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1207 set +o noglob; set -${shopts} #reset old shell opts
1208 return 0
1209 fi
1210 done
1211 set +o noglob; set -$shopts #reset old shell opts
1212
1213 local licmsg="$(emktemp)"
1214 cat << EOF > ${licmsg}
1215**********************************************************
1216The following license outlines the terms of use of this
1217package. You MUST accept this license for installation to
1218continue. When you are done viewing, hit 'q'. If you
1219CTRL+C out of this, the install will not run!
1220**********************************************************
1221
1222EOF
1223 cat ${lic} >> ${licmsg}
1224 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1225 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1226 read alic
1227 case ${alic} in
1228 yes|Yes|y|Y)
1229 return 0
1230 ;;
1231 *)
1232 echo;echo;echo
1233 eerror "You MUST accept the license to continue! Exiting!"
1234 die "Failed to accept license"
1235 ;;
1236 esac
1237}
1238
1239# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1164# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1240# the whole 'non-interactive' policy, but damnit I want CD support ! 1165# the whole 'non-interactive' policy, but damnit I want CD support !
1241# 1166#
1242# with these cdrom functions we handle all the user interaction and 1167# With these cdrom functions we handle all the user interaction and
1243# standardize everything. all you have to do is call cdrom_get_cds() 1168# standardize everything. All you have to do is call cdrom_get_cds()
1244# and when the function returns, you can assume that the cd has been 1169# and when the function returns, you can assume that the cd has been
1245# found at CDROM_ROOT. 1170# found at CDROM_ROOT.
1246# 1171#
1172# The function will attempt to locate a cd based upon a file that is on
1173# the cd. The more files you give this function, the more cds
1174# the cdrom functions will handle.
1175#
1247# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1176# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1248# etc... if you want to give the cds better names, then just export 1177# etc... If you want to give the cds better names, then just export
1249# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1178# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1179# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1180# also use the CDROM_NAME_SET bash array.
1250# 1181#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1182# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() { 1183cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by 1184 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us 1185 # the # of files they gave us
1260 local cdcnt=0 1186 local cdcnt=0
1261 local f= 1187 local f=
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1211 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1212 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1 1213 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do 1214 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET)) 1215 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break 1216 [[ -e ${CDROM_ROOT}/${f} ]] && break
1291 done 1217 done
1292 export CDROM_MATCH=${f} 1218 export CDROM_MATCH=${f}
1293 return 1219 return
1294 fi 1220 fi
1295 1221
1305 echo 1231 echo
1306 einfo "For example:" 1232 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom" 1233 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo 1234 echo
1309 else 1235 else
1236 if [[ -n ${CDROM_NAME_SET} ]] ; then
1237 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1238 cdcnt=0
1239 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1240 ((++cdcnt))
1241 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1242 done
1243 fi
1244
1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1245 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1311 cdcnt=0 1246 cdcnt=0
1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1247 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1313 ((++cdcnt)) 1248 ((++cdcnt))
1314 var="CDROM_NAME_${cdcnt}" 1249 var="CDROM_NAME_${cdcnt}"
1338 export CDROM_SET="" 1273 export CDROM_SET=""
1339 export CDROM_CURRENT_CD=0 1274 export CDROM_CURRENT_CD=0
1340 cdrom_load_next_cd 1275 cdrom_load_next_cd
1341} 1276}
1342 1277
1343# this is only used when you need access to more than one cd. 1278# @FUNCTION: cdrom_load_next_cd
1344# when you have finished using the first cd, just call this function. 1279# @DESCRIPTION:
1345# when it returns, CDROM_ROOT will be pointing to the second cd. 1280# Some packages are so big they come on multiple CDs. When you're done reading
1346# remember, you can only go forward in the cd chain, you can't go back. 1281# files off a CD and want access to the next one, just call this function.
1282# Again, all the messy details of user interaction are taken care of for you.
1283# Once this returns, just read the variable CDROM_ROOT for the location of the
1284# mounted CD. Note that you can only go forward in the CD list, so make sure
1285# you only call this function when you're done using the current CD.
1347cdrom_load_next_cd() { 1286cdrom_load_next_cd() {
1348 local var 1287 local var
1349 ((++CDROM_CURRENT_CD)) 1288 ((++CDROM_CURRENT_CD))
1350 1289
1351 unset CDROM_ROOT 1290 unset CDROM_ROOT
1368# displayed and we'll hang out here until: 1307# displayed and we'll hang out here until:
1369# (1) the file is found on a mounted cdrom 1308# (1) the file is found on a mounted cdrom
1370# (2) the user hits CTRL+C 1309# (2) the user hits CTRL+C
1371_cdrom_locate_file_on_cd() { 1310_cdrom_locate_file_on_cd() {
1372 local mline="" 1311 local mline=""
1373 local showedmsg=0 1312 local showedmsg=0 showjolietmsg=0
1374 1313
1375 while [[ -z ${CDROM_ROOT} ]] ; do 1314 while [[ -z ${CDROM_ROOT} ]] ; do
1376 local i=0 1315 local i=0
1377 local -a cdset=(${*//:/ }) 1316 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then 1317 if [[ -n ${CDROM_SET} ]] ; then
1381 1320
1382 while [[ -n ${cdset[${i}]} ]] ; do 1321 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]}) 1322 local dir=$(dirname ${cdset[${i}]})
1384 local file=$(basename ${cdset[${i}]}) 1323 local file=$(basename ${cdset[${i}]})
1385 1324
1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1325 local point= node= fs= foo=
1326 while read point node fs foo ; do
1327 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1328 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1329 && continue
1330 point=${point//\040/ }
1387 [[ -d ${mline}/${dir} ]] || continue 1331 [[ ! -d ${point}/${dir} ]] && continue
1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1332 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1389 export CDROM_ROOT=${mline} 1333 export CDROM_ROOT=${point}
1390 export CDROM_SET=${i} 1334 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]} 1335 export CDROM_MATCH=${cdset[${i}]}
1392 return 1336 return
1393 fi 1337 done <<< "$(get_mounts)"
1394 done
1395 1338
1396 ((++i)) 1339 ((++i))
1397 done 1340 done
1398 1341
1399 echo 1342 echo
1415 showedmsg=1 1358 showedmsg=1
1416 fi 1359 fi
1417 einfo "Press return to scan for the cd again" 1360 einfo "Press return to scan for the cd again"
1418 einfo "or hit CTRL+C to abort the emerge." 1361 einfo "or hit CTRL+C to abort the emerge."
1419 echo 1362 echo
1363 if [[ ${showjolietmsg} -eq 0 ]] ; then
1364 showjolietmsg=1
1365 else
1420 einfo "If you are having trouble with the detection" 1366 ewarn "If you are having trouble with the detection"
1421 einfo "of your CD, it is possible that you do not have" 1367 ewarn "of your CD, it is possible that you do not have"
1422 einfo "Joliet support enabled in your kernel. Please" 1368 ewarn "Joliet support enabled in your kernel. Please"
1423 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1369 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1370 ebeep 5
1371 fi
1424 read || die "something is screwed with your system" 1372 read || die "something is screwed with your system"
1425 done 1373 done
1426} 1374}
1427 1375
1376# @FUNCTION: strip-linguas
1377# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1378# @DESCRIPTION:
1428# Make sure that LINGUAS only contains languages that 1379# Make sure that LINGUAS only contains languages that
1429# a package can support 1380# a package can support. The first form allows you to
1430# 1381# specify a list of LINGUAS. The -i builds a list of po
1431# usage: strip-linguas <allow LINGUAS> 1382# files found in all the directories and uses the
1432# strip-linguas -i <directories of .po files> 1383# intersection of the lists. The -u builds a list of po
1433# strip-linguas -u <directories of .po files> 1384# files found in all the directories and uses the union
1434# 1385# of the lists.
1435# The first form allows you to specify a list of LINGUAS.
1436# The -i builds a list of po files found in all the
1437# directories and uses the intersection of the lists.
1438# The -u builds a list of po files found in all the
1439# directories and uses the union of the lists.
1440strip-linguas() { 1386strip-linguas() {
1441 local ls newls 1387 local ls newls nols
1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1388 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1443 local op=$1; shift 1389 local op=$1; shift
1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1390 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1445 local d f 1391 local d f
1446 for d in "$@" ; do 1392 for d in "$@" ; do
1447 if [[ ${op} == "-u" ]] ; then 1393 if [[ ${op} == "-u" ]] ; then
1448 newls=${ls} 1394 newls=${ls}
1449 else 1395 else
1450 newls="" 1396 newls=""
1451 fi 1397 fi
1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1398 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1453 if [[ ${op} == "-i" ]] ; then 1399 if [[ ${op} == "-i" ]] ; then
1454 hasq ${f} ${ls} && newls="${newls} ${f}" 1400 has ${f} ${ls} && newls="${newls} ${f}"
1455 else 1401 else
1456 hasq ${f} ${ls} || newls="${newls} ${f}" 1402 has ${f} ${ls} || newls="${newls} ${f}"
1457 fi 1403 fi
1458 done 1404 done
1459 ls=${newls} 1405 ls=${newls}
1460 done 1406 done
1461 else 1407 else
1462 ls="$@" 1408 ls="$@"
1463 fi 1409 fi
1464 1410
1411 nols=""
1465 newls="" 1412 newls=""
1466 for f in ${LINGUAS} ; do 1413 for f in ${LINGUAS} ; do
1467 if hasq ${f} ${ls} ; then 1414 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1415 newls="${newls} ${f}"
1469 else 1416 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1417 nols="${nols} ${f}"
1471 fi 1418 fi
1472 done 1419 done
1420 [[ -n ${nols} ]] \
1421 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1473 export LINGUAS=${newls:1} 1422 export LINGUAS=${newls:1}
1474} 1423}
1475 1424
1476# moved from kernel.eclass since they are generally useful outside of 1425# @FUNCTION: preserve_old_lib
1477# kernel.eclass -iggy (20041002) 1426# @USAGE: <libs to preserve> [more libs]
1478 1427# @DESCRIPTION:
1479# the following functions are useful in kernel module ebuilds, etc.
1480# for an example see ivtv or drbd ebuilds
1481
1482# set's ARCH to match what the kernel expects
1483set_arch_to_kernel() {
1484 i=10
1485 while ((i--)) ; do
1486 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1487 done
1488 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1489 case ${ARCH} in
1490 x86) export ARCH="i386";;
1491 amd64) export ARCH="x86_64";;
1492 hppa) export ARCH="parisc";;
1493 mips) export ARCH="mips";;
1494 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1495 *) export ARCH="${ARCH}";;
1496 esac
1497}
1498
1499# set's ARCH back to what portage expects
1500set_arch_to_portage() {
1501 i=10
1502 while ((i--)) ; do
1503 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1504 done
1505 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1506}
1507
1508# Jeremy Huddleston <eradicator@gentoo.org>:
1509# preserve_old_lib /path/to/libblah.so.0
1510# preserve_old_lib_notify /path/to/libblah.so.0
1511#
1512# These functions are useful when a lib in your package changes --library. Such 1428# These functions are useful when a lib in your package changes ABI SONAME.
1513# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1429# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1514# would break packages that link against it. Most people get around this 1430# would break packages that link against it. Most people get around this
1515# by using the portage SLOT mechanism, but that is not always a relevant 1431# by using the portage SLOT mechanism, but that is not always a relevant
1516# solution, so instead you can add the following to your ebuilds: 1432# solution, so instead you can call this from pkg_preinst. See also the
1517# 1433# preserve_old_lib_notify function.
1518# src_install() {
1519# ...
1520# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1521# ...
1522# }
1523#
1524# pkg_postinst() {
1525# ...
1526# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1527# ...
1528# }
1529
1530preserve_old_lib() { 1434preserve_old_lib() {
1531 LIB=$1 1435 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1436 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1437 die "Invalid preserve_old_lib() usage"
1438 fi
1439 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1532 1440
1533 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1441 # let portage worry about it
1534 SONAME=`basename ${LIB}` 1442 has preserve-libs ${FEATURES} && return 0
1535 DIRNAME=`dirname ${LIB}`
1536 1443
1537 dodir ${DIRNAME} 1444 local lib dir
1538 cp ${ROOT}${LIB} ${D}${DIRNAME} 1445 for lib in "$@" ; do
1446 [[ -e ${ROOT}/${lib} ]] || continue
1447 dir=${lib%/*}
1448 dodir ${dir} || die "dodir ${dir} failed"
1449 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1539 touch ${D}${LIB} 1450 touch "${D}"/${lib}
1540 fi 1451 done
1541} 1452}
1542 1453
1454# @FUNCTION: preserve_old_lib_notify
1455# @USAGE: <libs to notify> [more libs]
1456# @DESCRIPTION:
1457# Spit helpful messages about the libraries preserved by preserve_old_lib.
1543preserve_old_lib_notify() { 1458preserve_old_lib_notify() {
1544 LIB=$1 1459 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1460 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1461 die "Invalid preserve_old_lib_notify() usage"
1462 fi
1545 1463
1546 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1464 # let portage worry about it
1547 SONAME=`basename ${LIB}` 1465 has preserve-libs ${FEATURES} && return 0
1548 1466
1467 local lib notice=0
1468 for lib in "$@" ; do
1469 [[ -e ${ROOT}/${lib} ]] || continue
1470 if [[ ${notice} -eq 0 ]] ; then
1471 notice=1
1549 ewarn "An old version of an installed library was detected on your system." 1472 ewarn "Old versions of installed libraries were detected on your system."
1550 ewarn "In order to avoid breaking packages that link against it, this older version" 1473 ewarn "In order to avoid breaking packages that depend on these old libs,"
1551 ewarn "is not being removed. In order to make full use of this newer version," 1474 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1552 ewarn "you will need to execute the following command:" 1475 ewarn "in order to remove these old dependencies. If you do not have this"
1476 ewarn "helper program, simply emerge the 'gentoolkit' package."
1477 ewarn
1478 fi
1479 # temp hack for #348634 #357225
1480 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1553 ewarn " revdep-rebuild --library ${SONAME}" 1481 ewarn " # revdep-rebuild --library '${lib}'"
1482 done
1483 if [[ ${notice} -eq 1 ]] ; then
1554 ewarn 1484 ewarn
1555 ewarn "After doing that, you can safely remove ${LIB}" 1485 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1556 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1486 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1487 for lib in "$@" ; do
1488 ewarn " # rm '${lib}'"
1489 done
1557 fi 1490 fi
1558} 1491}
1559 1492
1560# Hack for people to figure out if a package was built with 1493# @FUNCTION: built_with_use
1561# certain USE flags 1494# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1495# @DESCRIPTION:
1562# 1496#
1563# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1497# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1564# ex: built_with_use xchat gtk2
1565# 1498#
1566# Flags: -a all USE flags should be utilized 1499# A temporary hack until portage properly supports DEPENDing on USE
1567# -o at least one USE flag should be utilized 1500# flags being enabled in packages. This will check to see if the specified
1568# Note: the default flag is '-a' 1501# DEPEND atom was built with the specified list of USE flags. The
1502# --missing option controls the behavior if called on a package that does
1503# not actually support the defined USE flags (aka listed in IUSE).
1504# The default is to abort (call die). The -a and -o flags control
1505# the requirements of the USE flags. They correspond to "and" and "or"
1506# logic. So the -a flag means all listed USE flags must be enabled
1507# while the -o flag means at least one of the listed IUSE flags must be
1508# enabled. The --hidden option is really for internal use only as it
1509# means the USE flag we're checking is hidden expanded, so it won't be found
1510# in IUSE like normal USE flags.
1511#
1512# Remember that this function isn't terribly intelligent so order of optional
1513# flags matter.
1569built_with_use() { 1514built_with_use() {
1515 local hidden="no"
1516 if [[ $1 == "--hidden" ]] ; then
1517 hidden="yes"
1518 shift
1519 fi
1520
1521 local missing_action="die"
1522 if [[ $1 == "--missing" ]] ; then
1523 missing_action=$2
1524 shift ; shift
1525 case ${missing_action} in
1526 true|false|die) ;;
1527 *) die "unknown action '${missing_action}'";;
1528 esac
1529 fi
1530
1570 local opt=$1 1531 local opt=$1
1571 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1532 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1572 1533
1573 local PKG=$(best_version $1) 1534 local PKG=$(best_version $1)
1535 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1574 shift 1536 shift
1575 1537
1576 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1538 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1539 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1577 1540
1578 # if the USE file doesnt exist, assume the $PKG is either 1541 # if the IUSE file doesn't exist, the read will error out, we need to handle
1579 # injected or package.provided 1542 # this gracefully
1580 [[ ! -e ${USEFILE} ]] && return 0 1543 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1544 case ${missing_action} in
1545 true) return 0;;
1546 false) return 1;;
1547 die) die "Unable to determine what USE flags $PKG was built with";;
1548 esac
1549 fi
1550
1551 if [[ ${hidden} == "no" ]] ; then
1552 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1553 # Don't check USE_EXPAND #147237
1554 local expand
1555 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1556 if [[ $1 == ${expand}_* ]] ; then
1557 expand=""
1558 break
1559 fi
1560 done
1561 if [[ -n ${expand} ]] ; then
1562 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1563 case ${missing_action} in
1564 true) return 0;;
1565 false) return 1;;
1566 die) die "$PKG does not actually support the $1 USE flag!";;
1567 esac
1568 fi
1569 fi
1570 fi
1581 1571
1582 local USE_BUILT=$(<${USEFILE}) 1572 local USE_BUILT=$(<${USEFILE})
1583 while [[ $# -gt 0 ]] ; do 1573 while [[ $# -gt 0 ]] ; do
1584 if [[ ${opt} = "-o" ]] ; then 1574 if [[ ${opt} = "-o" ]] ; then
1585 has $1 ${USE_BUILT} && return 0 1575 has $1 ${USE_BUILT} && return 0
1589 shift 1579 shift
1590 done 1580 done
1591 [[ ${opt} = "-a" ]] 1581 [[ ${opt} = "-a" ]]
1592} 1582}
1593 1583
1584# @FUNCTION: epunt_cxx
1585# @USAGE: [dir to scan]
1586# @DESCRIPTION:
1594# Many configure scripts wrongly bail when a C++ compiler 1587# Many configure scripts wrongly bail when a C++ compiler could not be
1595# could not be detected. #73450 1588# detected. If dir is not specified, then it defaults to ${S}.
1589#
1590# http://bugs.gentoo.org/73450
1596epunt_cxx() { 1591epunt_cxx() {
1597 local dir=$1 1592 local dir=$1
1598 [[ -z ${dir} ]] && dir=${S} 1593 [[ -z ${dir} ]] && dir=${S}
1599 ebegin "Removing useless C++ checks" 1594 ebegin "Removing useless C++ checks"
1600 local f 1595 local f
1601 for f in $(find ${dir} -name configure) ; do 1596 find "${dir}" -name configure | while read f ; do
1602 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1597 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1603 done 1598 done
1604 eend 0 1599 eend 0
1605} 1600}
1606 1601
1607# dopamd <file> [more files] 1602# @FUNCTION: make_wrapper
1608# 1603# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1609# Install pam auth config file in /etc/pam.d 1604# @DESCRIPTION:
1610dopamd() { 1605# Create a shell wrapper script named wrapper in installpath
1611 [[ -z $1 ]] && die "dopamd requires at least one argument" 1606# (defaults to the bindir) to execute target (default of wrapper) by
1612 1607# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1613 use pam || return 0 1608# libpaths followed by optionally changing directory to chdir.
1614
1615 INSDESTTREE=/etc/pam.d \
1616 doins "$@" || die "failed to install $@"
1617}
1618# newpamd <old name> <new name>
1619#
1620# Install pam file <old name> as <new name> in /etc/pam.d
1621newpamd() {
1622 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1623
1624 use pam || return 0
1625
1626 INSDESTTREE=/etc/pam.d \
1627 newins "$1" "$2" || die "failed to install $1 as $2"
1628}
1629
1630# make a wrapper script ...
1631# NOTE: this was originally games_make_wrapper, but I noticed other places where
1632# this could be used, so I have moved it here and made it not games-specific
1633# -- wolf31o2
1634# $1 == wrapper name
1635# $2 == binary to run
1636# $3 == directory to chdir before running binary
1637# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1638# $5 == path for wrapper
1639make_wrapper() { 1609make_wrapper() {
1640 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1610 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1641 local tmpwrapper=$(emktemp) 1611 local tmpwrapper=$(emktemp)
1642 # We don't want to quote ${bin} so that people can pass complex 1612 # We don't want to quote ${bin} so that people can pass complex
1643 # things as $bin ... "./someprog --args" 1613 # things as $bin ... "./someprog --args"
1653fi 1623fi
1654exec ${bin} "\$@" 1624exec ${bin} "\$@"
1655EOF 1625EOF
1656 chmod go+rx "${tmpwrapper}" 1626 chmod go+rx "${tmpwrapper}"
1657 if [[ -n ${path} ]] ; then 1627 if [[ -n ${path} ]] ; then
1628 (
1658 exeinto "${path}" 1629 exeinto "${path}"
1659 newexe "${tmpwrapper}" "${wrapper}" 1630 newexe "${tmpwrapper}" "${wrapper}"
1631 ) || die
1660 else 1632 else
1661 newbin "${tmpwrapper}" "${wrapper}" 1633 newbin "${tmpwrapper}" "${wrapper}" || die
1634 fi
1635}
1636
1637# @FUNCTION: path_exists
1638# @USAGE: [-a|-o] <paths>
1639# @DESCRIPTION:
1640# Check if the specified paths exist. Works for all types of paths
1641# (files/dirs/etc...). The -a and -o flags control the requirements
1642# of the paths. They correspond to "and" and "or" logic. So the -a
1643# flag means all the paths must exist while the -o flag means at least
1644# one of the paths must exist. The default behavior is "and". If no
1645# paths are specified, then the return value is "false".
1646path_exists() {
1647 local opt=$1
1648 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1649
1650 # no paths -> return false
1651 # same behavior as: [[ -e "" ]]
1652 [[ $# -eq 0 ]] && return 1
1653
1654 local p r=0
1655 for p in "$@" ; do
1656 [[ -e ${p} ]]
1657 : $(( r += $? ))
1658 done
1659
1660 case ${opt} in
1661 -a) return $(( r != 0 )) ;;
1662 -o) return $(( r == $# )) ;;
1663 esac
1664}
1665
1666# @FUNCTION: in_iuse
1667# @USAGE: <flag>
1668# @DESCRIPTION:
1669# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1670# as necessary.
1671#
1672# Note that this function should not be used in the global scope.
1673in_iuse() {
1674 debug-print-function ${FUNCNAME} "${@}"
1675 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1676
1677 local flag=${1}
1678 local liuse=( ${IUSE} )
1679
1680 has "${flag}" "${liuse[@]#[+-]}"
1681}
1682
1683# @FUNCTION: use_if_iuse
1684# @USAGE: <flag>
1685# @DESCRIPTION:
1686# Return true if the given flag is in USE and IUSE.
1687#
1688# Note that this function should not be used in the global scope.
1689use_if_iuse() {
1690 in_iuse $1 || return 1
1691 use $1
1692}
1693
1694# @FUNCTION: usex
1695# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1696# @DESCRIPTION:
1697# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1698# otherwise echo [false output][false suffix] (defaults to "no").
1699usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1700
1701check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1702
1662 fi 1703fi
1663}

Legend:
Removed from v.1.237  
changed lines
  Added in v.1.374

  ViewVC Help
Powered by ViewVC 1.1.20